#!/bin/sh

# %%%% TeXTallion %%%%
# Tiny almost-Kiss Word Processor
# http://anamnese.online.fr/site2/textallion/docs/presentation.html
# Complete source code: http://textallion.googlecode.com
# License: http://creativecommons.org/licenses/by-sa/3.0/

# initiate the variables, from the user's input

function create_new_doc(){

echo -e "\nTEXTALLION, the tiny almost-Kiss Word Processor\n-----------------------------------------------\nThis script will initiate a new document.\n"

echo "What is the name of the document file (and folder) to be created? (Try to avoid accented letters, spaces and funky characters)"
read DOCUMENTNAME

echo "What is the title name of the document file to be created? "
read DOCUMENTTITLE

echo "Who is the author?"
read AUTHORNAME

echo "What are the tags defining this document (separated by commas)?"
read DOCTAGS

echo "What is the language code of the document (2 letters, i.e. 'en' for English)?"
read DOCLANG

# replace space by underscore for the output files, remove accented letters, lower case

DOCUMENTFOLDER=`echo ${DOCUMENTNAME} | sed 's/ /_/g' | sed 's/\x27/_/g' | sed 's/[êèéëÊÈÉË]/e/g' | sed 's/[îìíïÎÏ]/i/g' | sed 's/[áåàäâÀÂÄ]/a/g' | sed 's/[øôóòöÔÖ]/o/g' | sed 's/[üûùúÙÛÜ]/u/g' | sed y/ABCDEFGHIJKLMNOPQRSTUVWXYZçÿ/abcdefghijklmnopqrstuvwxyzcy/ `
}



function setup(){
mkdir ~/${DOCUMENTFOLDER}

cp /usr/share/textallion/samples/makefile ~/${DOCUMENTFOLDER}
cp /usr/share/textallion/includes/sample.css ~/${DOCUMENTFOLDER}/${DOCUMENTFOLDER}.css
cp /usr/share/textallion/includes/sample.sty ~/${DOCUMENTFOLDER}/${DOCUMENTFOLDER}.sty


sed -i -e "s@TEXTALLIONFOLDER = ../@TEXTALLIONFOLDER = /usr/share/textallion/@g" ~/${DOCUMENTFOLDER}/makefile
sed -i -e "s@DOCUMENT = examples@DOCUMENT = ${DOCUMENTFOLDER}@g" ~/${DOCUMENTFOLDER}/makefile
sed -i -e "s@xx DOCUMENT LANGUAGE xx@${DOCLANG}@g" ~/${DOCUMENTFOLDER}/makefile
sed -i -e "s@xx DOCUMENT AUTHOR xx@${AUTHORNAME}@g" ~/${DOCUMENTFOLDER}/makefile
sed -i -e "s@xx DOCUMENT AUTHOR xx@${AUTHORNAME}@g" ~/${DOCUMENTFOLDER}/${DOCUMENTFOLDER}.sty
sed -i -e "s@xx DOCUMENT TITLE xx@${DOCUMENTTITLE}@g" ~/${DOCUMENTFOLDER}/makefile
sed -i -e "s@xx DOCUMENT TITLE xx@${DOCUMENTTITLE}@g" ~/${DOCUMENTFOLDER}/${DOCUMENTFOLDER}.sty
sed -i -e "s@xx DOCUMENT TAGS xx@${DOCTAGS}@g" ~/${DOCUMENTFOLDER}/makefile
sed -i -e "s@xx DOCUMENT TAGS xx@${DOCTAGS}@g" ~/${DOCUMENTFOLDER}/${DOCUMENTFOLDER}.sty




echo ${DOCUMENTTITLE} > ~/${DOCUMENTFOLDER}/${DOCUMENTFOLDER}.t2t
echo ${AUTHORNAME}   >> ~/${DOCUMENTFOLDER}/${DOCUMENTFOLDER}.t2t
echo -e "`date +%Y-%m-%d`\n"   >> ~/${DOCUMENTFOLDER}/${DOCUMENTFOLDER}.t2t
echo -e "%!style(tex): ${DOCUMENTFOLDER}.sty\n" >> ~/${DOCUMENTFOLDER}/${DOCUMENTFOLDER}.t2t
echo -e "%!style(xhtml): ${DOCUMENTFOLDER}.css\n\n" >> ~/${DOCUMENTFOLDER}/${DOCUMENTFOLDER}.t2t
echo -e "%!includeconf: /usr/share/textallion/core/textallion.t2t\n" >> ~/${DOCUMENTFOLDER}/${DOCUMENTFOLDER}.t2t
echo -e "%!postproc(tex): 'TEXTALLIONPATH' '/usr/share/textallion/'\n\n" >> ~/${DOCUMENTFOLDER}/${DOCUMENTFOLDER}.t2t


echo "${DOCUMENTFOLDER} was created into your home folder. Now enter this folder, edit ~/${DOCUMENTFOLDER}/${DOCUMENTFOLDER}.t2t and at the end to generate the final documents, type \"make pdf\" or \"make html\"..."
}

function test_folder(){
if [ -e ~/${DOCUMENTFOLDER} ]; then 
	echo "This folder ~/${DOCUMENTFOLDER} is already present. Please choose another name or remove this folder, and run \"textallion\" again."
	exit
else
	setup
fi
}

create_new_doc
test_folder

